/* Copyright (c) 2002 Petr Bilek
Tento kod je volne programove vybaveni; muzete jej sirit a modifikovat
podle ustanoveni Obecne verejne license GNU, vydavane FreeSoftware Foundation.
Na tento program se nevztahuji ZADNE ZARUKY; neposkytuji se ani odvozene zaruky
PRODEJNSTI anebo VHODNOSTI PRO URCITY UCEL. */
/* soubor  vl_datum.c PROFI */
#ifdef PSANIPROFI

#include <unistd.h>
#include <stdlib.h>
#include <pthread.h>
#include <time.h>

#include "strukturyw.h"
#include "struktury.h"
#include "libw.h"
#include "lib.h"
#include "barvy.h"

time_t the_time;
struct tm *tm_ptr;

void *vl_obnov_datum(void *arg)
{
    int i;
    i = pthread_setcanceltype(PTHREAD_CANCEL_ASYNCHRONOUS, NULL);
    if (i && (global_get(g_warning) == g_w_ano)) {
        print_hl(1,
                 "vl_obnov_datum: Selhalo nastaveni priznaku ukonceni funkce varovani");
        return NULL;
    }
    wattron2(new_datum, COLOR_PAIR(COLOR_DATUM_HLAVNI));
    do {
        pthread_testcancel();
        (void) time(&the_time);
        tm_ptr = localtime(&the_time);
        MVWPRINTW2(new_datum, 0, 0,
                   " datum: %02d.%02d.%02d, as: %02d:%02d.%02d ",
                   tm_ptr->tm_mday, tm_ptr->tm_mon + 1,
                   tm_ptr->tm_year + 1900, tm_ptr->tm_hour,
                   tm_ptr->tm_min, tm_ptr->tm_sec);
        tiskni_dle_priority();
        sleep(1);
    }
    while (1);

    pthread_exit(0);
}
#endif
