/* Copyright (c) 2002 Petr Bilek
   Tento kod je volne programove vybaveni; muzete jej sirit a modifikovat
podle ustanoveni Obecne verejne license GNU, vydavane FreeSoftware Foundation.
Na tento program se nevztahuji ZADNE ZARUKY; neposkytuji se ani odvozene zaruky
PRODEJNSTI anebo VHODNOSTI PRO URCITY UCEL. */
/* soubor vybertest.c */

#include <limits.h>
#include "strukturyw.h"
#include "struktury.h"
#include "libw.h"
#include "lib.h"

int vyber_test(type_uziv * slozka, type_nastaveni * nastaveni, int MIN,
               int MAX)
{
    int i, ch;
    static int l;
    type_informace test;
    int napoveda = 0;

    obnov_nadpis1(slozka, nastaveni);

    if ((l < MIN) || (l > MAX))
        for (i = 0; i < MAX; i++)
            if (!slozka->napsano_test[i]) {
                if (i + 1 >= MIN)
                    l = i + 1;
                break;
            }
    if ((l < MIN) || (l > MAX))
        l = MIN;
#ifndef PSANIPROFI
    werase2(sub_informace);
#else
    vymaz_okno(sub_informace);
#endif
    do {
        test = informace_o_testech(l, slozka);

        if (!napoveda)
            vypis_info(test, nastaveni);
        else
            vypis_napoveda(jmeno_napovedy_testu(l), 1);

        for (i = MIN; i <= MAX; i++) {
            if (i == l)
                wattron2(sub_informace, /*A_BOLD */ A_REVERSE);
            MVWPRINTW2(sub_informace, i - MIN + 1, 1, "Test  %02i", i);
            if (i == l)
                wattroff2(sub_informace, /*A_BOLD */ A_REVERSE);
        }

        obnov_informace();
        tiskni_dle_priority();

        ch = getch3();

        if (ch == '\t')
            napoveda = !napoveda;

        if (((ch == KEY_DOWN) || (ch == 't')) && l < MAX)
            l++;
        else if (((ch == KEY_UP) || (ch == 'T')) && l > MIN)
            l--;

        if (ch == 'k' || ch == 'K')
            return 0;

        if (ch == '\n') {
            /* prinutime uzivatele si nejdrive precist napovedu */
            if (!napoveda) {
                napoveda = !napoveda;
            } else if (test.zavislost)
                return l;
            else {
                print_hl(1,
                         "Nejdve je nutn napsat pedchoz LEKCI nebo test !");
            }
        }
    }
    while (TRUE);

}
